/*
 * Main.java
 *
 * Created on 2007/10/09, 0:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.kujirahand.sakura;

import com.kujirahand.utils.Tokenizer;
import javax.sound.midi.Sequencer;

/**
 *
 * @author kujira
 */
public class Main {
    
    public Song song;
    public SkrParser parser;
    public Sequencer sequencer;
    
    public Main() {
        song = new Song();
    }
    
    public void setMML(String mml) throws ParseException {
        SkrTokenizer tok = new SkrTokenizer(mml, "system");
        parser = new SkrParser(song, tok);
        parser.execute();
    }
    
    public void compile() {
        SkrMidiWriter writer = new SkrMidiWriter(parser);
        sequencer = writer.writeMidiTrack();
    }
    
    public void play() {
        if (sequencer != null) {
            try {
                sequencer.start();
                while (sequencer.isRunning()) Thread.sleep(100);
                sequencer.close();
            } catch (Exception e){
                e.printStackTrace();
            }
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            Main main = new Main();
            main.setMML("テンポ200 どれみふぁそ テンポ80どれみふぁ");
            main.compile();
            main.play();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
}
