/*
 * SkrMidiWriter.java
 *
 * Created on 2007/10/14, 21:49
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.kujirahand.sakura;

import com.kujirahand.sakura.event.TrackEvent;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import javax.sound.midi.*;
import javax.sound.midi.spi.MidiFileWriter;

/**
 *
 * @author kujira
 */
public class SkrMidiWriter {
    
    SkrParser parser;
    
    public SkrMidiWriter(SkrParser parser) {
        this.parser = parser;
    }
    
    public Sequencer writeMidiTrack() {
        Song song = parser.song;
        Sequencer sequencer = null;
        try {
            sequencer = MidiSystem.getSequencer();
            sequencer.open();
            // set timebase
            Sequence seq = new Sequence(Sequence.PPQ, song.timebase);
            // write event
            for (int i = 0; i < song.tracks.size(); i++) {            
                SkrTrack strack = (SkrTrack)song.tracks.get(i);
                Track miditrack = seq.createTrack();
                for (int j = 0; j < strack.events.size(); j++) {
                    TrackEvent e = (TrackEvent)strack.events.get(j);
                    e.writeMidiTrack(miditrack);
                }
            }
            MidiSystem.write(seq, 1, new File("c:/Users/kujira/a.mid"));
            sequencer.setSequence(seq);
            
        } catch (Exception e) {
            e.printStackTrace();
        }
        return sequencer;
    }
}
