/*
 * SkrTrack.java
 *
 * Created on 2007/10/14, 0:18
 */

package com.kujirahand.sakura;

import com.kujirahand.sakura.command.SCommand;
import com.kujirahand.utils.Tokenizer;

/**
 *
 * @author kujira
 */
public class SkrTrack {
    
    public Song song;
    public int velocity;
    public int octave;
    public int length;
    public int gate;
    public int time;
    public int timing;
    public TrackEvents events;
    public int channel;
    
    public SkrTrack(Song song) {
        this.song = song;
        init();
    }
    
    private void init() {
        // create
        events = new TrackEvents();
        // set params
        time     = 0;
        velocity = 100;
        octave   = 5;
        gate     = 80;
        length   = song.timebase;
        timing   = 0;
    }
    
    public int calcLength(String src) {
        // check base length
        SkrTokenizer tok = new SkrTokenizer(src,"calcLength");
        tok.skipSpace();
        int len = calcLength_sub(tok);
        while (!tok.EOS()) {
            tok.skipSpace();
            if (!tok.startsWith('^')) break;
            tok.next(1); // skip '^'
            int addlen = calcLength_sub(tok);
            len += addlen;
        }
        return len;
    }
    
    private int calcLength_sub(SkrTokenizer tok) {
        int len;
        if (tok.startsWith('%')) {
            tok.next(1);
            len = tok.getInt(Integer.MAX_VALUE);
            if (len == Integer.MAX_VALUE) {
                throw new RuntimeException(Lang.msg(Lang.PARSER_LENGTH_ERROR));
            }
        } else {
            len = tok.getInt(SCommand.DEFAULT_PARAM_I);
            if (len == SCommand.DEFAULT_PARAM_I) {
                len = length;
            } else {
                int zen = song.timebase * 4;
                len = zen / len;
            }
        }
        while (tok.startsWith('.')) {
            tok.next(1);
            len *= 1.5;
        }
        return len;
    }
    
}
