/*
 * SCommand.java
 *
 * Created on 2007/10/14, 2:22
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.kujirahand.sakura.command;

import com.kujirahand.sakura.*;
import java.util.Vector;

/**
 *
 * @author kujira
 */
public class SCommand {
    
    public static int DEFAULT_PARAM_I = Integer.MAX_VALUE;
    public static int VALUE_ABSOLUTE = 0;
    public static int VALUE_RELATIVE = 1;
    
    public int lineno;
    public int fileno;
    
    public Vector args = null;
    
    public SCommand() {
    }
    /**
     * @return  if true, increment pointer.
     */
    public boolean execute(Song song) {
        return true;
    }
    
    public void getParams(SkrTokenizer tok, String cmd_name) throws ParseException {
        char c = tok.getCur();
        if (c == '=' || c == ' ' || c == '\t' || c == '(' || c == '{') {
            // has params
            tok.skipSpace();
        } else {
            return;
        }
        args = new Vector();
        if (c == '=') tok.next(1);
        while (!tok.EOS()) {
            char ch = tok.getCur();
            
            if (ch == '{') {
                String str = tok.getStringRange();
                args.add(new SkrValue(str));
            }
            else if (tok.isNumberic(ch)) {
                int i = tok.getInt(0);
                args.add(new SkrValue(i));
            }
            else if (ch == '(') {
                String r = tok.getParethesisRange();
                SkrValue expr = new SkrValue();
                expr.type = SkrValue.TYPE_EXPR;
                expr.value = r;
                args.add(expr);
            }
            else if (tok.isUpperCase(ch)) { // variable or function
                String var = tok.getCommand();
                tok.skipSpace();
                if (tok.getCur() == '(') {
                    var += tok.getParethesisRange();
                }
                SkrValue expr = new SkrValue();
                expr.type = SkrValue.TYPE_EXPR;
                expr.value = var;
                args.add(expr);
            } else {
                // no value
                args.add(new SkrValue());
            }
            tok.skipSpace();
            if (tok.getCur() != ',') break;
            tok.next(1);
        }
    }
    
}
