/*
 * SCommandNote.java
 *
 * Created on 2007/10/14, 2:22
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.kujirahand.sakura.command;

import com.kujirahand.sakura.*;
import com.kujirahand.sakura.event.TrackEventNoteOn;

/**
 *
 * @author kujira
 */
public class SCommandNote extends SCommand {
    
    public char note;
    public int sharp = 0;
    public String length;
    public int gate = SCommand.DEFAULT_PARAM_I;
    public boolean gate_stepmode = false;
    public int velocity = SCommand.DEFAULT_PARAM_I;
    public int velocity_mode = SCommand.VALUE_ABSOLUTE;
    public int timing = SCommand.DEFAULT_PARAM_I;
    public int timing_mode = SCommand.VALUE_ABSOLUTE;
    
    //                                 a, b,c,d,e,f,g
    public static int[] notetable = {9,11,0,2,4,5,7};
    
    public SCommandNote() {
    }
    
    public boolean execute(Song song) {
        SkrTrack track = song.cur_track;
        // noteno
        int o = track.octave * 12;
        int noteno = o + notetable[(int)note - (int)'a']; // TODO: calc noteno
        noteno += sharp;
        // len
        int vlen = track.calcLength(length);
        // time
        int vtime = track.time;
        // velocity
        int vvel = (velocity != SCommand.DEFAULT_PARAM_I) ? velocity : track.velocity;
        if (velocity_mode == SCommand.VALUE_RELATIVE) vvel += track.velocity;
        // gate
        int vgate = (gate != SCommand.DEFAULT_PARAM_I) ? gate : track.gate;
        if (!gate_stepmode) {
            vgate = (int)Math.floor(vlen * (vgate * 0.01));
        }
        // timing
        int vtiming = (timing != SCommand.DEFAULT_PARAM_I) ? timing : track.timing;
        if (timing_mode == SCommand.VALUE_RELATIVE) vtiming += track.timing;
        // calc time
        vtime += vtiming;
        // write
        TrackEventNoteOn noteon = new TrackEventNoteOn(track, vtime, noteno, vvel, vgate);
        track.events.add(noteon);
        // next
        track.time += vlen;
        return true;
    }
    
}
