/*
 * TrackEventNoteOn.java
 *
 * Created on 2007/10/14, 14:43
 */

package com.kujirahand.sakura.event;

import com.kujirahand.sakura.*;
import javax.sound.midi.*;

/**
 * @author kujira
 */
public class TrackEventNoteOn extends TrackEvent {
    
    public int noteno;
    public int velocity;
    public int gate;
    
    public TrackEventNoteOn(SkrTrack track, int time, int noteno, int velocity, int gate) {
        this.track = track;
        this.time = time;
        this.event = ShortMessage.NOTE_ON;
        this.noteno = noteno;
        this.velocity = velocity;
        this.gate = gate;
    }
    
    public void writeMidiTrack(Track miditrack) {
        // note on
        writeShortMessage(miditrack, time, ShortMessage.NOTE_ON, noteno, velocity);
        // note off
        int time_off = time + gate;
        writeShortMessage(miditrack, time_off, ShortMessage.NOTE_OFF, noteno, 0);
    }
    
}
