/*
 * TrackEventTempo.java
 *
 * Created on 2007/10/14, 21:31
 */

package com.kujirahand.sakura.event;

import com.kujirahand.sakura.*;
import javax.sound.midi.*;

/**
 *
 * @author kujira
 */
public class TrackEventTempo extends TrackEvent {
    
    public int tempo;
    
    public TrackEventTempo(SkrTrack track, int time, int tempo) {
        this.track = track;
        this.time = time;
        this.tempo = tempo;
        this.event = 0x51;
    }
    
    public void writeMidiTrack(Track miditrack) {
        try {
            // calc tempo to msec
            int msec = 60000000 / tempo;
            byte[] tempo_ary = new byte[3];
            tempo_ary[0] = (byte)(msec >> 16);
            tempo_ary[1] = (byte)((msec >> 8) & 0xFF);
            tempo_ary[2] = (byte)(msec & 0xFF);
            // set meta event
            MetaMessage meta = new MetaMessage();
            meta.setMessage(0x51, tempo_ary, 3);
            miditrack.add(new MidiEvent(meta, time));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
}
